﻿Imports Infragistics.Win.UltraWinGrid
Imports Infragistics.Win

Public Class Form1
    Dim _cell As UltraGridCell

    Private Sub UltraGrid1_InitializeLayout(sender As System.Object, e As Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs) Handles UltraGrid1.InitializeLayout

    End Sub

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load

        Dim dt As DataTable = New DataTable()
        dt.Columns.Add("Col1", GetType(String)).DefaultValue = "Col1"
        dt.Columns.Add("Col2", GetType(String)).DefaultValue = "Col2"
        dt.Columns.Add("Col3", GetType(String)).DefaultValue = "Col3"

        For index = 1 To 10
            dt.Rows.Add()

        Next

        UltraGrid1.DataSource = dt

    End Sub

    Private Sub UltraGrid1_AfterExitEditMode(sender As System.Object, e As System.EventArgs) Handles UltraGrid1.AfterExitEditMode

    End Sub

    Private Sub UltraGrid1_AfterCellUpdate(sender As System.Object, e As Infragistics.Win.UltraWinGrid.CellEventArgs) Handles UltraGrid1.AfterCellUpdate
        If e.Cell.Column.Key = "Col2" Or e.Cell.Column.Key = "Col3" Then
            If e.Cell.Value.ToString() = "0" Then
                UltraGrid1.EventManager.SetEnabled(Infragistics.Win.UltraWinGrid.EventGroups.AfterEvents, False)
                For Each cell As UltraGridCell In e.Cell.Row.Cells
                    cell.Value = Nothing
                Next
                _cell = e.Cell.Row.Cells(0)

                UltraGrid1.ActiveCell = e.Cell.Row.Cells(0)
                UltraGrid1.PerformAction(UltraGridAction.EnterEditMode)
                UltraGrid1.EventManager.SetEnabled(Infragistics.Win.UltraWinGrid.EventGroups.AfterEvents, True)
            End If
        End If
    End Sub

   

    Private Sub UltraGrid1_BeforeCellDeactivate(sender As System.Object, e As System.ComponentModel.CancelEventArgs) Handles UltraGrid1.BeforeCellDeactivate
        If UltraGrid1.ActiveCell.Equals(_cell) Then

            e.Cancel = True
            UltraGrid1.ActiveCell = _cell
            DirectCast(_cell.EditorResolved, EditorWithText).EnterEditMode(_cell.GetUIElement().ChildElements(0))
            _cell = Nothing
        End If
    End Sub

End Class
